#ifndef CCMRMAC_
#define CCMRMAC_


/* TOPOLOGY defs */
/* Attention the ID equal to 0 it's reserved for MAC internal use                   */
/* the nodes GEOADDR use a uint32 variable, the first 16 bit are x coordinate       */
/* and the last 16 bit are the y coordinate; allowed coordinate values are beetween */
/* 0 and 65535 limits                 																*/

#define VER_STEP 118
#define HOR_STEP 160
#define VER_OFFSET 60
#define HOR_OFFSET 60
#define FIRST_ADDR 21
#define VER_UBOUND 886
#define HOR_UBOUND 860


uint32_t geo_pos(uint16_t id) {
	return ((uint32_t)(HOR_OFFSET+((id - FIRST_ADDR)%6)*HOR_STEP))<<16|(VER_OFFSET + ((id - FIRST_ADDR) / 6)*VER_STEP);
}

uint8_t geo_neigh(uint32_t pos) {
	uint16_t x = pos >> 16 ;
	uint16_t y = pos & 0x0000FFFF;
	return (5 + 3*(((x > HOR_OFFSET) & (x < HOR_UBOUND)) ^ ((y > VER_OFFSET) & (y < VER_UBOUND))) + 7 * ((x > HOR_OFFSET) & (x < HOR_UBOUND) & (y > VER_OFFSET) & (y < VER_UBOUND)));
}

/* Prob.Table */
const uint16_t TayProbTable[20][10]={
{909,909,909,909,909,909,909,909,909,909},	//2
{593,613,636,663,695,735,786,856,960,1152},	//3
{441,463,489,520,557,604,666,754,890,1154},	//4
{351,372,397,426,463,510,572,661,803,1089},	//5
{292,311,334,361,396,440,500,585,725,1010},	//6
{249,267,288,313,345,387,442,524,657,933},	//7
{218,234,253,277,306,344,397,473,599,862},	//8
{193,208,226,248,275,311,359,431,549,800},	//9
{174,188,204,224,249,283,328,395,507,745},	//10
{145,156,171,188,210,240,280,339,439,653},	//12
{124,134,147,162,182,208,243,297,386,580},	//14
{108,118,129,143,160,183,216,264,345,521},	//16
{96,105,115,127,143,164,193,237,311,473},		//18
{87,94,103,115,129,149,175,215,283,432},		//20
{69,75,83,92,104,120,142,175,232,356},			//25
{58,63,69,77,87,101,119,148,196,303},			//30
{49,54,59,66,75,87,103,128,170,263},			//35
{43,47,52,58,66,76,91,112,150,233},				//40
{38,42,46,52,59,68,81,100,134,208},				//45
{35,38,42,47,53,61,73,91,121,189}};  			//50

const uint8_t tablepos[20] = {2,3,4,5,6,7,8,9,10,12,14,16,18,20,25,30,35,40,45,50};

uint16_t findTayVal(uint8_t neighNum, uint8_t slotNum){
	uint8_t idx;
	for (idx = 0; tablepos[idx] > neighNum ; idx++);
	return TayProbTable[idx][slotNum - 1];
}

/* Params */

/*tempi per il tx*/
#define SENSE_TIME    3597 
#define DEFER_RTS_TIME 32 
#define WAIT_CTS_TIME 4251
#define DEFER_DATA_TIME 32 
#define WAIT_ACK_TIME 654 
// #define MAX_BACKOFF 3597
#define MAX_BACKOFF 512
#define MIN_BACKOFF 4
#define CSMA_PERIOD 654
#define SENSE_PERIOD 32
/*tempi per il ricevitore  FACENDO USO DI TIMERMILLI*/
#define DEFER_CTS_TIME 32
#define WAIT_DATA_TIME 16350 
#define DEFER_ACK_TIME 32 
#define FULL_BATTERY 10000
#define SELFISHNESS 0

/*tempi per tx e rx*/
#define SLOT_TIME 392
//#define RTS_SLOT_TIME 524 
#define SWITCH_RADIO_OFFSET 64
#define IDLE_TIME  4000
#define MAIN_TIMER_VALUE_INIT 3270 
#define WIN_SIZE 10
#define MIN_COST_RANGE 550
/* sta in sleep per SLEEP_TIME ms, sta in sleepBackoff per [min,max]=[SLEEP_TIME,MAX_SLEEP_BACKOFF_TIME]
		quindi: (MAX_SLEEP_BACKOFF_TIME)-(SLEEP_TIME)=num a cui satura il random*/
#define SLEEP_TIME 0 
#define SLEEP_RTS 2567
#define SLEEP_CTS 2060
#define SLEEP_DATA 523
#define WAIT_RTS_TX 1500
#define WAIT_CTS_TX 700
#define WAIT_DATA_TX 1500
#define WAIT_ACK_TX 700

//#define MAX_SLEEP_BACKOFF_TIME 500
/* MAX_RANDOM = (2^ ceil(log2(MAX_SLEEP_BACKOFF_TIME - SLEEP_TIME)))-1 */
//#define MAX_RANDOM 0x01FF 

/* COSTANTI VARIE */
#define MAX_TRIALS 7

#define DIM_QUEUE 16

/*raggio di trasmissione di un nodo*/
#define RADIUS 250 
#define SCALE 10000

#define ADC_BUFFERSIZE 5
#define RSSILEVEL 5000



#endif
