#ifndef CCMRMSG_H
#define CCMRMSG_H


/*Marshaller settings*/
#define CCMRMSG_HEAD_SIZE 6
#define CCMR_LENGTH_BYTE_OFFSET 0
#define CCMR_NUM_PREAMBLES 2
#define CCMR_TOSH_HEADER_LENGTH offsetof(struct TOS_Msg, data)
#define CCMR_TOSH_DATA_LENGTH 58
#define CCMR_TICKS 17

typedef struct CCMR_Rts { 
	uint16_t IdSink;
	uint32_t GeoSinkAddr;
	uint32_t GeoLocalAddr;
	uint16_t Distance;
	uint16_t Cmin;
	uint16_t Cmax;
	uint8_t Neigh;
} CCMR_Rts;

typedef struct CCMR_Msg {	
	uint8_t length;
	uint8_t type;
	uint16_t s_addr;
	uint16_t addr;
	TOS_Msg data;
	uint16_t crc;
	uint16_t strength;
} CCMR_Msg;

typedef enum{
	CCMR_RTS_MSG,
	CCMR_CTS_MSG,
	CCMR_DATA_MSG,
	CCMR_ACK_MSG,
} CCMR_MsgType;

#endif

